# coding: utf-8

from __future__ import absolute_import
from datetime import date, datetime  # noqa: F401

from typing import List, Dict  # noqa: F401

from swagger_server.models.base_model_ import Model
from swagger_server.models.timeline import Timeline
from swagger_server import util


class Article(Model):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    def __init__(self, id: int=None, title: str=None, doi: str=None, handle: str=None, url: str=None, url_public_html: str=None, url_public_api: str=None, url_private_html: str=None, url_private_api: str=None, timeline: Timeline=None, thumb: str=None, defined_type: int=None, defined_type_name: str=None):  # noqa: E501
        """Article - a model defined in Swagger

        :param id: The id of this Article.  # noqa: E501
        :type id: int
        :param title: The title of this Article.  # noqa: E501
        :type title: str
        :param doi: The doi of this Article.  # noqa: E501
        :type doi: str
        :param handle: The handle of this Article.  # noqa: E501
        :type handle: str
        :param url: The url of this Article.  # noqa: E501
        :type url: str
        :param url_public_html: The url_public_html of this Article.  # noqa: E501
        :type url_public_html: str
        :param url_public_api: The url_public_api of this Article.  # noqa: E501
        :type url_public_api: str
        :param url_private_html: The url_private_html of this Article.  # noqa: E501
        :type url_private_html: str
        :param url_private_api: The url_private_api of this Article.  # noqa: E501
        :type url_private_api: str
        :param timeline: The timeline of this Article.  # noqa: E501
        :type timeline: Timeline
        :param thumb: The thumb of this Article.  # noqa: E501
        :type thumb: str
        :param defined_type: The defined_type of this Article.  # noqa: E501
        :type defined_type: int
        :param defined_type_name: The defined_type_name of this Article.  # noqa: E501
        :type defined_type_name: str
        """
        self.swagger_types = {
            'id': int,
            'title': str,
            'doi': str,
            'handle': str,
            'url': str,
            'url_public_html': str,
            'url_public_api': str,
            'url_private_html': str,
            'url_private_api': str,
            'timeline': Timeline,
            'thumb': str,
            'defined_type': int,
            'defined_type_name': str
        }

        self.attribute_map = {
            'id': 'id',
            'title': 'title',
            'doi': 'doi',
            'handle': 'handle',
            'url': 'url',
            'url_public_html': 'url_public_html',
            'url_public_api': 'url_public_api',
            'url_private_html': 'url_private_html',
            'url_private_api': 'url_private_api',
            'timeline': 'timeline',
            'thumb': 'thumb',
            'defined_type': 'defined_type',
            'defined_type_name': 'defined_type_name'
        }

        self._id = id
        self._title = title
        self._doi = doi
        self._handle = handle
        self._url = url
        self._url_public_html = url_public_html
        self._url_public_api = url_public_api
        self._url_private_html = url_private_html
        self._url_private_api = url_private_api
        self._timeline = timeline
        self._thumb = thumb
        self._defined_type = defined_type
        self._defined_type_name = defined_type_name

    @classmethod
    def from_dict(cls, dikt) -> 'Article':
        """Returns the dict as a model

        :param dikt: A dict.
        :type: dict
        :return: The Article of this Article.  # noqa: E501
        :rtype: Article
        """
        return util.deserialize_model(dikt, cls)

    @property
    def id(self) -> int:
        """Gets the id of this Article.

        Unique identifier for article  # noqa: E501

        :return: The id of this Article.
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id: int):
        """Sets the id of this Article.

        Unique identifier for article  # noqa: E501

        :param id: The id of this Article.
        :type id: int
        """
        if id is None:
            raise ValueError("Invalid value for `id`, must not be `None`")  # noqa: E501

        self._id = id

    @property
    def title(self) -> str:
        """Gets the title of this Article.

        Title of article  # noqa: E501

        :return: The title of this Article.
        :rtype: str
        """
        return self._title

    @title.setter
    def title(self, title: str):
        """Sets the title of this Article.

        Title of article  # noqa: E501

        :param title: The title of this Article.
        :type title: str
        """
        if title is None:
            raise ValueError("Invalid value for `title`, must not be `None`")  # noqa: E501

        self._title = title

    @property
    def doi(self) -> str:
        """Gets the doi of this Article.

        DOI  # noqa: E501

        :return: The doi of this Article.
        :rtype: str
        """
        return self._doi

    @doi.setter
    def doi(self, doi: str):
        """Sets the doi of this Article.

        DOI  # noqa: E501

        :param doi: The doi of this Article.
        :type doi: str
        """
        if doi is None:
            raise ValueError("Invalid value for `doi`, must not be `None`")  # noqa: E501

        self._doi = doi

    @property
    def handle(self) -> str:
        """Gets the handle of this Article.

        Handle  # noqa: E501

        :return: The handle of this Article.
        :rtype: str
        """
        return self._handle

    @handle.setter
    def handle(self, handle: str):
        """Sets the handle of this Article.

        Handle  # noqa: E501

        :param handle: The handle of this Article.
        :type handle: str
        """
        if handle is None:
            raise ValueError("Invalid value for `handle`, must not be `None`")  # noqa: E501

        self._handle = handle

    @property
    def url(self) -> str:
        """Gets the url of this Article.

        Api endpoint for article  # noqa: E501

        :return: The url of this Article.
        :rtype: str
        """
        return self._url

    @url.setter
    def url(self, url: str):
        """Sets the url of this Article.

        Api endpoint for article  # noqa: E501

        :param url: The url of this Article.
        :type url: str
        """
        if url is None:
            raise ValueError("Invalid value for `url`, must not be `None`")  # noqa: E501

        self._url = url

    @property
    def url_public_html(self) -> str:
        """Gets the url_public_html of this Article.

        Public site endpoint for article  # noqa: E501

        :return: The url_public_html of this Article.
        :rtype: str
        """
        return self._url_public_html

    @url_public_html.setter
    def url_public_html(self, url_public_html: str):
        """Sets the url_public_html of this Article.

        Public site endpoint for article  # noqa: E501

        :param url_public_html: The url_public_html of this Article.
        :type url_public_html: str
        """
        if url_public_html is None:
            raise ValueError("Invalid value for `url_public_html`, must not be `None`")  # noqa: E501

        self._url_public_html = url_public_html

    @property
    def url_public_api(self) -> str:
        """Gets the url_public_api of this Article.

        Public Api endpoint for article  # noqa: E501

        :return: The url_public_api of this Article.
        :rtype: str
        """
        return self._url_public_api

    @url_public_api.setter
    def url_public_api(self, url_public_api: str):
        """Sets the url_public_api of this Article.

        Public Api endpoint for article  # noqa: E501

        :param url_public_api: The url_public_api of this Article.
        :type url_public_api: str
        """
        if url_public_api is None:
            raise ValueError("Invalid value for `url_public_api`, must not be `None`")  # noqa: E501

        self._url_public_api = url_public_api

    @property
    def url_private_html(self) -> str:
        """Gets the url_private_html of this Article.

        Private site endpoint for article  # noqa: E501

        :return: The url_private_html of this Article.
        :rtype: str
        """
        return self._url_private_html

    @url_private_html.setter
    def url_private_html(self, url_private_html: str):
        """Sets the url_private_html of this Article.

        Private site endpoint for article  # noqa: E501

        :param url_private_html: The url_private_html of this Article.
        :type url_private_html: str
        """
        if url_private_html is None:
            raise ValueError("Invalid value for `url_private_html`, must not be `None`")  # noqa: E501

        self._url_private_html = url_private_html

    @property
    def url_private_api(self) -> str:
        """Gets the url_private_api of this Article.

        Private Api endpoint for article  # noqa: E501

        :return: The url_private_api of this Article.
        :rtype: str
        """
        return self._url_private_api

    @url_private_api.setter
    def url_private_api(self, url_private_api: str):
        """Sets the url_private_api of this Article.

        Private Api endpoint for article  # noqa: E501

        :param url_private_api: The url_private_api of this Article.
        :type url_private_api: str
        """
        if url_private_api is None:
            raise ValueError("Invalid value for `url_private_api`, must not be `None`")  # noqa: E501

        self._url_private_api = url_private_api

    @property
    def timeline(self) -> Timeline:
        """Gets the timeline of this Article.

        Various timeline dates  # noqa: E501

        :return: The timeline of this Article.
        :rtype: Timeline
        """
        return self._timeline

    @timeline.setter
    def timeline(self, timeline: Timeline):
        """Sets the timeline of this Article.

        Various timeline dates  # noqa: E501

        :param timeline: The timeline of this Article.
        :type timeline: Timeline
        """
        if timeline is None:
            raise ValueError("Invalid value for `timeline`, must not be `None`")  # noqa: E501

        self._timeline = timeline

    @property
    def thumb(self) -> str:
        """Gets the thumb of this Article.

        Thumbnail image  # noqa: E501

        :return: The thumb of this Article.
        :rtype: str
        """
        return self._thumb

    @thumb.setter
    def thumb(self, thumb: str):
        """Sets the thumb of this Article.

        Thumbnail image  # noqa: E501

        :param thumb: The thumb of this Article.
        :type thumb: str
        """
        if thumb is None:
            raise ValueError("Invalid value for `thumb`, must not be `None`")  # noqa: E501

        self._thumb = thumb

    @property
    def defined_type(self) -> int:
        """Gets the defined_type of this Article.

        Type of article identifier  # noqa: E501

        :return: The defined_type of this Article.
        :rtype: int
        """
        return self._defined_type

    @defined_type.setter
    def defined_type(self, defined_type: int):
        """Sets the defined_type of this Article.

        Type of article identifier  # noqa: E501

        :param defined_type: The defined_type of this Article.
        :type defined_type: int
        """
        if defined_type is None:
            raise ValueError("Invalid value for `defined_type`, must not be `None`")  # noqa: E501

        self._defined_type = defined_type

    @property
    def defined_type_name(self) -> str:
        """Gets the defined_type_name of this Article.

        Name of the article type identifier  # noqa: E501

        :return: The defined_type_name of this Article.
        :rtype: str
        """
        return self._defined_type_name

    @defined_type_name.setter
    def defined_type_name(self, defined_type_name: str):
        """Sets the defined_type_name of this Article.

        Name of the article type identifier  # noqa: E501

        :param defined_type_name: The defined_type_name of this Article.
        :type defined_type_name: str
        """
        if defined_type_name is None:
            raise ValueError("Invalid value for `defined_type_name`, must not be `None`")  # noqa: E501

        self._defined_type_name = defined_type_name
