# coding: utf-8

from __future__ import absolute_import
from datetime import date, datetime  # noqa: F401

from typing import List, Dict  # noqa: F401

from swagger_server.models.base_model_ import Model
from swagger_server.models.custom_article_field_add import CustomArticleFieldAdd
from swagger_server.models.funding_create import FundingCreate
from swagger_server.models.related_material import RelatedMaterial
from swagger_server.models.timeline_update import TimelineUpdate
from swagger_server import util


class ArticleUpdate(Model):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    def __init__(self, title: str=None, description: str='', is_metadata_record: bool=None, metadata_reason: str=None, tags: List[str]=None, keywords: List[str]=None, references: List[str]=None, related_materials: List[RelatedMaterial]=None, categories: List[int]=None, categories_by_source_id: List[str]=None, authors: List[object]=None, custom_fields: object=None, custom_fields_list: List[CustomArticleFieldAdd]=None, defined_type: str=None, funding: str='', funding_list: List[FundingCreate]=None, license: int=0, doi: str='', handle: str='', resource_doi: str='', resource_title: str='', timeline: TimelineUpdate=None, download_disabled: bool=None, group_id: int=None):  # noqa: E501
        """ArticleUpdate - a model defined in Swagger

        :param title: The title of this ArticleUpdate.  # noqa: E501
        :type title: str
        :param description: The description of this ArticleUpdate.  # noqa: E501
        :type description: str
        :param is_metadata_record: The is_metadata_record of this ArticleUpdate.  # noqa: E501
        :type is_metadata_record: bool
        :param metadata_reason: The metadata_reason of this ArticleUpdate.  # noqa: E501
        :type metadata_reason: str
        :param tags: The tags of this ArticleUpdate.  # noqa: E501
        :type tags: List[str]
        :param keywords: The keywords of this ArticleUpdate.  # noqa: E501
        :type keywords: List[str]
        :param references: The references of this ArticleUpdate.  # noqa: E501
        :type references: List[str]
        :param related_materials: The related_materials of this ArticleUpdate.  # noqa: E501
        :type related_materials: List[RelatedMaterial]
        :param categories: The categories of this ArticleUpdate.  # noqa: E501
        :type categories: List[int]
        :param categories_by_source_id: The categories_by_source_id of this ArticleUpdate.  # noqa: E501
        :type categories_by_source_id: List[str]
        :param authors: The authors of this ArticleUpdate.  # noqa: E501
        :type authors: List[object]
        :param custom_fields: The custom_fields of this ArticleUpdate.  # noqa: E501
        :type custom_fields: object
        :param custom_fields_list: The custom_fields_list of this ArticleUpdate.  # noqa: E501
        :type custom_fields_list: List[CustomArticleFieldAdd]
        :param defined_type: The defined_type of this ArticleUpdate.  # noqa: E501
        :type defined_type: str
        :param funding: The funding of this ArticleUpdate.  # noqa: E501
        :type funding: str
        :param funding_list: The funding_list of this ArticleUpdate.  # noqa: E501
        :type funding_list: List[FundingCreate]
        :param license: The license of this ArticleUpdate.  # noqa: E501
        :type license: int
        :param doi: The doi of this ArticleUpdate.  # noqa: E501
        :type doi: str
        :param handle: The handle of this ArticleUpdate.  # noqa: E501
        :type handle: str
        :param resource_doi: The resource_doi of this ArticleUpdate.  # noqa: E501
        :type resource_doi: str
        :param resource_title: The resource_title of this ArticleUpdate.  # noqa: E501
        :type resource_title: str
        :param timeline: The timeline of this ArticleUpdate.  # noqa: E501
        :type timeline: TimelineUpdate
        :param download_disabled: The download_disabled of this ArticleUpdate.  # noqa: E501
        :type download_disabled: bool
        :param group_id: The group_id of this ArticleUpdate.  # noqa: E501
        :type group_id: int
        """
        self.swagger_types = {
            'title': str,
            'description': str,
            'is_metadata_record': bool,
            'metadata_reason': str,
            'tags': List[str],
            'keywords': List[str],
            'references': List[str],
            'related_materials': List[RelatedMaterial],
            'categories': List[int],
            'categories_by_source_id': List[str],
            'authors': List[object],
            'custom_fields': object,
            'custom_fields_list': List[CustomArticleFieldAdd],
            'defined_type': str,
            'funding': str,
            'funding_list': List[FundingCreate],
            'license': int,
            'doi': str,
            'handle': str,
            'resource_doi': str,
            'resource_title': str,
            'timeline': TimelineUpdate,
            'download_disabled': bool,
            'group_id': int
        }

        self.attribute_map = {
            'title': 'title',
            'description': 'description',
            'is_metadata_record': 'is_metadata_record',
            'metadata_reason': 'metadata_reason',
            'tags': 'tags',
            'keywords': 'keywords',
            'references': 'references',
            'related_materials': 'related_materials',
            'categories': 'categories',
            'categories_by_source_id': 'categories_by_source_id',
            'authors': 'authors',
            'custom_fields': 'custom_fields',
            'custom_fields_list': 'custom_fields_list',
            'defined_type': 'defined_type',
            'funding': 'funding',
            'funding_list': 'funding_list',
            'license': 'license',
            'doi': 'doi',
            'handle': 'handle',
            'resource_doi': 'resource_doi',
            'resource_title': 'resource_title',
            'timeline': 'timeline',
            'download_disabled': 'download_disabled',
            'group_id': 'group_id'
        }

        self._title = title
        self._description = description
        self._is_metadata_record = is_metadata_record
        self._metadata_reason = metadata_reason
        self._tags = tags
        self._keywords = keywords
        self._references = references
        self._related_materials = related_materials
        self._categories = categories
        self._categories_by_source_id = categories_by_source_id
        self._authors = authors
        self._custom_fields = custom_fields
        self._custom_fields_list = custom_fields_list
        self._defined_type = defined_type
        self._funding = funding
        self._funding_list = funding_list
        self._license = license
        self._doi = doi
        self._handle = handle
        self._resource_doi = resource_doi
        self._resource_title = resource_title
        self._timeline = timeline
        self._download_disabled = download_disabled
        self._group_id = group_id

    @classmethod
    def from_dict(cls, dikt) -> 'ArticleUpdate':
        """Returns the dict as a model

        :param dikt: A dict.
        :type: dict
        :return: The ArticleUpdate of this ArticleUpdate.  # noqa: E501
        :rtype: ArticleUpdate
        """
        return util.deserialize_model(dikt, cls)

    @property
    def title(self) -> str:
        """Gets the title of this ArticleUpdate.

        Title of article  # noqa: E501

        :return: The title of this ArticleUpdate.
        :rtype: str
        """
        return self._title

    @title.setter
    def title(self, title: str):
        """Sets the title of this ArticleUpdate.

        Title of article  # noqa: E501

        :param title: The title of this ArticleUpdate.
        :type title: str
        """
        if title is not None and len(title) > 1000:
            raise ValueError("Invalid value for `title`, length must be less than or equal to `1000`")  # noqa: E501
        if title is not None and len(title) < 3:
            raise ValueError("Invalid value for `title`, length must be greater than or equal to `3`")  # noqa: E501

        self._title = title

    @property
    def description(self) -> str:
        """Gets the description of this ArticleUpdate.

        The article description. In a publisher case, usually this is the remote article description  # noqa: E501

        :return: The description of this ArticleUpdate.
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description: str):
        """Sets the description of this ArticleUpdate.

        The article description. In a publisher case, usually this is the remote article description  # noqa: E501

        :param description: The description of this ArticleUpdate.
        :type description: str
        """
        if description is not None and len(description) > 10000:
            raise ValueError("Invalid value for `description`, length must be less than or equal to `10000`")  # noqa: E501

        self._description = description

    @property
    def is_metadata_record(self) -> bool:
        """Gets the is_metadata_record of this ArticleUpdate.

        True if article has no files  # noqa: E501

        :return: The is_metadata_record of this ArticleUpdate.
        :rtype: bool
        """
        return self._is_metadata_record

    @is_metadata_record.setter
    def is_metadata_record(self, is_metadata_record: bool):
        """Sets the is_metadata_record of this ArticleUpdate.

        True if article has no files  # noqa: E501

        :param is_metadata_record: The is_metadata_record of this ArticleUpdate.
        :type is_metadata_record: bool
        """

        self._is_metadata_record = is_metadata_record

    @property
    def metadata_reason(self) -> str:
        """Gets the metadata_reason of this ArticleUpdate.

        Article metadata reason  # noqa: E501

        :return: The metadata_reason of this ArticleUpdate.
        :rtype: str
        """
        return self._metadata_reason

    @metadata_reason.setter
    def metadata_reason(self, metadata_reason: str):
        """Sets the metadata_reason of this ArticleUpdate.

        Article metadata reason  # noqa: E501

        :param metadata_reason: The metadata_reason of this ArticleUpdate.
        :type metadata_reason: str
        """

        self._metadata_reason = metadata_reason

    @property
    def tags(self) -> List[str]:
        """Gets the tags of this ArticleUpdate.

        List of tags to be associated with the article. Keywords can be used instead  # noqa: E501

        :return: The tags of this ArticleUpdate.
        :rtype: List[str]
        """
        return self._tags

    @tags.setter
    def tags(self, tags: List[str]):
        """Sets the tags of this ArticleUpdate.

        List of tags to be associated with the article. Keywords can be used instead  # noqa: E501

        :param tags: The tags of this ArticleUpdate.
        :type tags: List[str]
        """

        self._tags = tags

    @property
    def keywords(self) -> List[str]:
        """Gets the keywords of this ArticleUpdate.

        List of tags to be associated with the article. Tags can be used instead  # noqa: E501

        :return: The keywords of this ArticleUpdate.
        :rtype: List[str]
        """
        return self._keywords

    @keywords.setter
    def keywords(self, keywords: List[str]):
        """Sets the keywords of this ArticleUpdate.

        List of tags to be associated with the article. Tags can be used instead  # noqa: E501

        :param keywords: The keywords of this ArticleUpdate.
        :type keywords: List[str]
        """

        self._keywords = keywords

    @property
    def references(self) -> List[str]:
        """Gets the references of this ArticleUpdate.

        List of links to be associated with the article (e.g [\"http://link1\", \"http://link2\", \"http://link3\"])  # noqa: E501

        :return: The references of this ArticleUpdate.
        :rtype: List[str]
        """
        return self._references

    @references.setter
    def references(self, references: List[str]):
        """Sets the references of this ArticleUpdate.

        List of links to be associated with the article (e.g [\"http://link1\", \"http://link2\", \"http://link3\"])  # noqa: E501

        :param references: The references of this ArticleUpdate.
        :type references: List[str]
        """

        self._references = references

    @property
    def related_materials(self) -> List[RelatedMaterial]:
        """Gets the related_materials of this ArticleUpdate.

        List of related materials; supersedes references and resource DOI/title.  # noqa: E501

        :return: The related_materials of this ArticleUpdate.
        :rtype: List[RelatedMaterial]
        """
        return self._related_materials

    @related_materials.setter
    def related_materials(self, related_materials: List[RelatedMaterial]):
        """Sets the related_materials of this ArticleUpdate.

        List of related materials; supersedes references and resource DOI/title.  # noqa: E501

        :param related_materials: The related_materials of this ArticleUpdate.
        :type related_materials: List[RelatedMaterial]
        """

        self._related_materials = related_materials

    @property
    def categories(self) -> List[int]:
        """Gets the categories of this ArticleUpdate.

        List of category ids to be associated with the article(e.g [1, 23, 33, 66])  # noqa: E501

        :return: The categories of this ArticleUpdate.
        :rtype: List[int]
        """
        return self._categories

    @categories.setter
    def categories(self, categories: List[int]):
        """Sets the categories of this ArticleUpdate.

        List of category ids to be associated with the article(e.g [1, 23, 33, 66])  # noqa: E501

        :param categories: The categories of this ArticleUpdate.
        :type categories: List[int]
        """

        self._categories = categories

    @property
    def categories_by_source_id(self) -> List[str]:
        """Gets the categories_by_source_id of this ArticleUpdate.

        List of category source ids to be associated with the article, supersedes the categories property  # noqa: E501

        :return: The categories_by_source_id of this ArticleUpdate.
        :rtype: List[str]
        """
        return self._categories_by_source_id

    @categories_by_source_id.setter
    def categories_by_source_id(self, categories_by_source_id: List[str]):
        """Sets the categories_by_source_id of this ArticleUpdate.

        List of category source ids to be associated with the article, supersedes the categories property  # noqa: E501

        :param categories_by_source_id: The categories_by_source_id of this ArticleUpdate.
        :type categories_by_source_id: List[str]
        """

        self._categories_by_source_id = categories_by_source_id

    @property
    def authors(self) -> List[object]:
        """Gets the authors of this ArticleUpdate.

        List of authors to be associated with the article. The list can contain the following fields: id, name, first_name, last_name, email, orcid_id. If an id is supplied, it will take priority and everything else will be ignored. For adding more authors use the specific authors endpoint.  # noqa: E501

        :return: The authors of this ArticleUpdate.
        :rtype: List[object]
        """
        return self._authors

    @authors.setter
    def authors(self, authors: List[object]):
        """Sets the authors of this ArticleUpdate.

        List of authors to be associated with the article. The list can contain the following fields: id, name, first_name, last_name, email, orcid_id. If an id is supplied, it will take priority and everything else will be ignored. For adding more authors use the specific authors endpoint.  # noqa: E501

        :param authors: The authors of this ArticleUpdate.
        :type authors: List[object]
        """

        self._authors = authors

    @property
    def custom_fields(self) -> object:
        """Gets the custom_fields of this ArticleUpdate.

        List of key, values pairs to be associated with the article  # noqa: E501

        :return: The custom_fields of this ArticleUpdate.
        :rtype: object
        """
        return self._custom_fields

    @custom_fields.setter
    def custom_fields(self, custom_fields: object):
        """Sets the custom_fields of this ArticleUpdate.

        List of key, values pairs to be associated with the article  # noqa: E501

        :param custom_fields: The custom_fields of this ArticleUpdate.
        :type custom_fields: object
        """

        self._custom_fields = custom_fields

    @property
    def custom_fields_list(self) -> List[CustomArticleFieldAdd]:
        """Gets the custom_fields_list of this ArticleUpdate.

        List of custom fields values, supersedes custom_fields parameter  # noqa: E501

        :return: The custom_fields_list of this ArticleUpdate.
        :rtype: List[CustomArticleFieldAdd]
        """
        return self._custom_fields_list

    @custom_fields_list.setter
    def custom_fields_list(self, custom_fields_list: List[CustomArticleFieldAdd]):
        """Sets the custom_fields_list of this ArticleUpdate.

        List of custom fields values, supersedes custom_fields parameter  # noqa: E501

        :param custom_fields_list: The custom_fields_list of this ArticleUpdate.
        :type custom_fields_list: List[CustomArticleFieldAdd]
        """

        self._custom_fields_list = custom_fields_list

    @property
    def defined_type(self) -> str:
        """Gets the defined_type of this ArticleUpdate.

        <b>One of:</b> <code>figure</code> <code>online resource</code> <code>preprint</code> <code>book</code> <code>conference contribution</code> <code>media</code> <code>dataset</code> <code>poster</code> <code>journal contribution</code> <code>presentation</code> <code>thesis</code> <code>software</code>  # noqa: E501

        :return: The defined_type of this ArticleUpdate.
        :rtype: str
        """
        return self._defined_type

    @defined_type.setter
    def defined_type(self, defined_type: str):
        """Sets the defined_type of this ArticleUpdate.

        <b>One of:</b> <code>figure</code> <code>online resource</code> <code>preprint</code> <code>book</code> <code>conference contribution</code> <code>media</code> <code>dataset</code> <code>poster</code> <code>journal contribution</code> <code>presentation</code> <code>thesis</code> <code>software</code>  # noqa: E501

        :param defined_type: The defined_type of this ArticleUpdate.
        :type defined_type: str
        """

        self._defined_type = defined_type

    @property
    def funding(self) -> str:
        """Gets the funding of this ArticleUpdate.

        Grant number or funding authority  # noqa: E501

        :return: The funding of this ArticleUpdate.
        :rtype: str
        """
        return self._funding

    @funding.setter
    def funding(self, funding: str):
        """Sets the funding of this ArticleUpdate.

        Grant number or funding authority  # noqa: E501

        :param funding: The funding of this ArticleUpdate.
        :type funding: str
        """

        self._funding = funding

    @property
    def funding_list(self) -> List[FundingCreate]:
        """Gets the funding_list of this ArticleUpdate.

        Funding creation / update items  # noqa: E501

        :return: The funding_list of this ArticleUpdate.
        :rtype: List[FundingCreate]
        """
        return self._funding_list

    @funding_list.setter
    def funding_list(self, funding_list: List[FundingCreate]):
        """Sets the funding_list of this ArticleUpdate.

        Funding creation / update items  # noqa: E501

        :param funding_list: The funding_list of this ArticleUpdate.
        :type funding_list: List[FundingCreate]
        """

        self._funding_list = funding_list

    @property
    def license(self) -> int:
        """Gets the license of this ArticleUpdate.

        License id for this article.  # noqa: E501

        :return: The license of this ArticleUpdate.
        :rtype: int
        """
        return self._license

    @license.setter
    def license(self, license: int):
        """Sets the license of this ArticleUpdate.

        License id for this article.  # noqa: E501

        :param license: The license of this ArticleUpdate.
        :type license: int
        """

        self._license = license

    @property
    def doi(self) -> str:
        """Gets the doi of this ArticleUpdate.

        Not applicable for regular users. In an institutional case, make sure your group supports setting DOIs. This setting is applied by figshare via opening a ticket through our support/helpdesk system.  # noqa: E501

        :return: The doi of this ArticleUpdate.
        :rtype: str
        """
        return self._doi

    @doi.setter
    def doi(self, doi: str):
        """Sets the doi of this ArticleUpdate.

        Not applicable for regular users. In an institutional case, make sure your group supports setting DOIs. This setting is applied by figshare via opening a ticket through our support/helpdesk system.  # noqa: E501

        :param doi: The doi of this ArticleUpdate.
        :type doi: str
        """

        self._doi = doi

    @property
    def handle(self) -> str:
        """Gets the handle of this ArticleUpdate.

        Not applicable for regular users. In an institutional case, make sure your group supports setting Handles. This setting is applied by figshare via opening a ticket through our support/helpdesk system.  # noqa: E501

        :return: The handle of this ArticleUpdate.
        :rtype: str
        """
        return self._handle

    @handle.setter
    def handle(self, handle: str):
        """Sets the handle of this ArticleUpdate.

        Not applicable for regular users. In an institutional case, make sure your group supports setting Handles. This setting is applied by figshare via opening a ticket through our support/helpdesk system.  # noqa: E501

        :param handle: The handle of this ArticleUpdate.
        :type handle: str
        """

        self._handle = handle

    @property
    def resource_doi(self) -> str:
        """Gets the resource_doi of this ArticleUpdate.

        Deprecated by related materials. Not applicable to regular users. In a publisher case, this is the publisher article DOI.  # noqa: E501

        :return: The resource_doi of this ArticleUpdate.
        :rtype: str
        """
        return self._resource_doi

    @resource_doi.setter
    def resource_doi(self, resource_doi: str):
        """Sets the resource_doi of this ArticleUpdate.

        Deprecated by related materials. Not applicable to regular users. In a publisher case, this is the publisher article DOI.  # noqa: E501

        :param resource_doi: The resource_doi of this ArticleUpdate.
        :type resource_doi: str
        """

        self._resource_doi = resource_doi

    @property
    def resource_title(self) -> str:
        """Gets the resource_title of this ArticleUpdate.

        Deprecated by related materials. Not applicable to regular users. In a publisher case, this is the publisher article title.  # noqa: E501

        :return: The resource_title of this ArticleUpdate.
        :rtype: str
        """
        return self._resource_title

    @resource_title.setter
    def resource_title(self, resource_title: str):
        """Sets the resource_title of this ArticleUpdate.

        Deprecated by related materials. Not applicable to regular users. In a publisher case, this is the publisher article title.  # noqa: E501

        :param resource_title: The resource_title of this ArticleUpdate.
        :type resource_title: str
        """

        self._resource_title = resource_title

    @property
    def timeline(self) -> TimelineUpdate:
        """Gets the timeline of this ArticleUpdate.

        Various timeline dates  # noqa: E501

        :return: The timeline of this ArticleUpdate.
        :rtype: TimelineUpdate
        """
        return self._timeline

    @timeline.setter
    def timeline(self, timeline: TimelineUpdate):
        """Sets the timeline of this ArticleUpdate.

        Various timeline dates  # noqa: E501

        :param timeline: The timeline of this ArticleUpdate.
        :type timeline: TimelineUpdate
        """

        self._timeline = timeline

    @property
    def download_disabled(self) -> bool:
        """Gets the download_disabled of this ArticleUpdate.

        If true, downloading of files for this article is disabled  # noqa: E501

        :return: The download_disabled of this ArticleUpdate.
        :rtype: bool
        """
        return self._download_disabled

    @download_disabled.setter
    def download_disabled(self, download_disabled: bool):
        """Sets the download_disabled of this ArticleUpdate.

        If true, downloading of files for this article is disabled  # noqa: E501

        :param download_disabled: The download_disabled of this ArticleUpdate.
        :type download_disabled: bool
        """

        self._download_disabled = download_disabled

    @property
    def group_id(self) -> int:
        """Gets the group_id of this ArticleUpdate.

        Not applicable to regular users. This field is reserved to institutions/publishers with access to assign to specific groups  # noqa: E501

        :return: The group_id of this ArticleUpdate.
        :rtype: int
        """
        return self._group_id

    @group_id.setter
    def group_id(self, group_id: int):
        """Sets the group_id of this ArticleUpdate.

        Not applicable to regular users. This field is reserved to institutions/publishers with access to assign to specific groups  # noqa: E501

        :param group_id: The group_id of this ArticleUpdate.
        :type group_id: int
        """

        self._group_id = group_id
