# coding: utf-8

from __future__ import absolute_import
from datetime import date, datetime  # noqa: F401

from typing import List, Dict  # noqa: F401

from swagger_server.models.base_model_ import Model
from swagger_server.models.author import Author
from swagger_server import util


class AuthorComplete(Model):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    def __init__(self, id: int=None, full_name: str=None, is_active: bool=None, url_name: str=None, orcid_id: str=None, institution_id: int=None, group_id: int=None, first_name: str=None, last_name: str=None, is_public: int=None, job_title: str=None):  # noqa: E501
        """AuthorComplete - a model defined in Swagger

        :param id: The id of this AuthorComplete.  # noqa: E501
        :type id: int
        :param full_name: The full_name of this AuthorComplete.  # noqa: E501
        :type full_name: str
        :param is_active: The is_active of this AuthorComplete.  # noqa: E501
        :type is_active: bool
        :param url_name: The url_name of this AuthorComplete.  # noqa: E501
        :type url_name: str
        :param orcid_id: The orcid_id of this AuthorComplete.  # noqa: E501
        :type orcid_id: str
        :param institution_id: The institution_id of this AuthorComplete.  # noqa: E501
        :type institution_id: int
        :param group_id: The group_id of this AuthorComplete.  # noqa: E501
        :type group_id: int
        :param first_name: The first_name of this AuthorComplete.  # noqa: E501
        :type first_name: str
        :param last_name: The last_name of this AuthorComplete.  # noqa: E501
        :type last_name: str
        :param is_public: The is_public of this AuthorComplete.  # noqa: E501
        :type is_public: int
        :param job_title: The job_title of this AuthorComplete.  # noqa: E501
        :type job_title: str
        """
        self.swagger_types = {
            'id': int,
            'full_name': str,
            'is_active': bool,
            'url_name': str,
            'orcid_id': str,
            'institution_id': int,
            'group_id': int,
            'first_name': str,
            'last_name': str,
            'is_public': int,
            'job_title': str
        }

        self.attribute_map = {
            'id': 'id',
            'full_name': 'full_name',
            'is_active': 'is_active',
            'url_name': 'url_name',
            'orcid_id': 'orcid_id',
            'institution_id': 'institution_id',
            'group_id': 'group_id',
            'first_name': 'first_name',
            'last_name': 'last_name',
            'is_public': 'is_public',
            'job_title': 'job_title'
        }

        self._id = id
        self._full_name = full_name
        self._is_active = is_active
        self._url_name = url_name
        self._orcid_id = orcid_id
        self._institution_id = institution_id
        self._group_id = group_id
        self._first_name = first_name
        self._last_name = last_name
        self._is_public = is_public
        self._job_title = job_title

    @classmethod
    def from_dict(cls, dikt) -> 'AuthorComplete':
        """Returns the dict as a model

        :param dikt: A dict.
        :type: dict
        :return: The AuthorComplete of this AuthorComplete.  # noqa: E501
        :rtype: AuthorComplete
        """
        return util.deserialize_model(dikt, cls)

    @property
    def id(self) -> int:
        """Gets the id of this AuthorComplete.

        Author id  # noqa: E501

        :return: The id of this AuthorComplete.
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id: int):
        """Sets the id of this AuthorComplete.

        Author id  # noqa: E501

        :param id: The id of this AuthorComplete.
        :type id: int
        """
        if id is None:
            raise ValueError("Invalid value for `id`, must not be `None`")  # noqa: E501

        self._id = id

    @property
    def full_name(self) -> str:
        """Gets the full_name of this AuthorComplete.

        Author full name  # noqa: E501

        :return: The full_name of this AuthorComplete.
        :rtype: str
        """
        return self._full_name

    @full_name.setter
    def full_name(self, full_name: str):
        """Sets the full_name of this AuthorComplete.

        Author full name  # noqa: E501

        :param full_name: The full_name of this AuthorComplete.
        :type full_name: str
        """
        if full_name is None:
            raise ValueError("Invalid value for `full_name`, must not be `None`")  # noqa: E501

        self._full_name = full_name

    @property
    def is_active(self) -> bool:
        """Gets the is_active of this AuthorComplete.

        True if author has published items  # noqa: E501

        :return: The is_active of this AuthorComplete.
        :rtype: bool
        """
        return self._is_active

    @is_active.setter
    def is_active(self, is_active: bool):
        """Sets the is_active of this AuthorComplete.

        True if author has published items  # noqa: E501

        :param is_active: The is_active of this AuthorComplete.
        :type is_active: bool
        """
        if is_active is None:
            raise ValueError("Invalid value for `is_active`, must not be `None`")  # noqa: E501

        self._is_active = is_active

    @property
    def url_name(self) -> str:
        """Gets the url_name of this AuthorComplete.

        Author url name  # noqa: E501

        :return: The url_name of this AuthorComplete.
        :rtype: str
        """
        return self._url_name

    @url_name.setter
    def url_name(self, url_name: str):
        """Sets the url_name of this AuthorComplete.

        Author url name  # noqa: E501

        :param url_name: The url_name of this AuthorComplete.
        :type url_name: str
        """
        if url_name is None:
            raise ValueError("Invalid value for `url_name`, must not be `None`")  # noqa: E501

        self._url_name = url_name

    @property
    def orcid_id(self) -> str:
        """Gets the orcid_id of this AuthorComplete.

        Author Orcid  # noqa: E501

        :return: The orcid_id of this AuthorComplete.
        :rtype: str
        """
        return self._orcid_id

    @orcid_id.setter
    def orcid_id(self, orcid_id: str):
        """Sets the orcid_id of this AuthorComplete.

        Author Orcid  # noqa: E501

        :param orcid_id: The orcid_id of this AuthorComplete.
        :type orcid_id: str
        """
        if orcid_id is None:
            raise ValueError("Invalid value for `orcid_id`, must not be `None`")  # noqa: E501

        self._orcid_id = orcid_id

    @property
    def institution_id(self) -> int:
        """Gets the institution_id of this AuthorComplete.

        Institution id  # noqa: E501

        :return: The institution_id of this AuthorComplete.
        :rtype: int
        """
        return self._institution_id

    @institution_id.setter
    def institution_id(self, institution_id: int):
        """Sets the institution_id of this AuthorComplete.

        Institution id  # noqa: E501

        :param institution_id: The institution_id of this AuthorComplete.
        :type institution_id: int
        """
        if institution_id is None:
            raise ValueError("Invalid value for `institution_id`, must not be `None`")  # noqa: E501

        self._institution_id = institution_id

    @property
    def group_id(self) -> int:
        """Gets the group_id of this AuthorComplete.

        Group id  # noqa: E501

        :return: The group_id of this AuthorComplete.
        :rtype: int
        """
        return self._group_id

    @group_id.setter
    def group_id(self, group_id: int):
        """Sets the group_id of this AuthorComplete.

        Group id  # noqa: E501

        :param group_id: The group_id of this AuthorComplete.
        :type group_id: int
        """
        if group_id is None:
            raise ValueError("Invalid value for `group_id`, must not be `None`")  # noqa: E501

        self._group_id = group_id

    @property
    def first_name(self) -> str:
        """Gets the first_name of this AuthorComplete.

        First Name  # noqa: E501

        :return: The first_name of this AuthorComplete.
        :rtype: str
        """
        return self._first_name

    @first_name.setter
    def first_name(self, first_name: str):
        """Sets the first_name of this AuthorComplete.

        First Name  # noqa: E501

        :param first_name: The first_name of this AuthorComplete.
        :type first_name: str
        """
        if first_name is None:
            raise ValueError("Invalid value for `first_name`, must not be `None`")  # noqa: E501

        self._first_name = first_name

    @property
    def last_name(self) -> str:
        """Gets the last_name of this AuthorComplete.

        Last Name  # noqa: E501

        :return: The last_name of this AuthorComplete.
        :rtype: str
        """
        return self._last_name

    @last_name.setter
    def last_name(self, last_name: str):
        """Sets the last_name of this AuthorComplete.

        Last Name  # noqa: E501

        :param last_name: The last_name of this AuthorComplete.
        :type last_name: str
        """
        if last_name is None:
            raise ValueError("Invalid value for `last_name`, must not be `None`")  # noqa: E501

        self._last_name = last_name

    @property
    def is_public(self) -> int:
        """Gets the is_public of this AuthorComplete.

        if 1 then the author has published items  # noqa: E501

        :return: The is_public of this AuthorComplete.
        :rtype: int
        """
        return self._is_public

    @is_public.setter
    def is_public(self, is_public: int):
        """Sets the is_public of this AuthorComplete.

        if 1 then the author has published items  # noqa: E501

        :param is_public: The is_public of this AuthorComplete.
        :type is_public: int
        """
        if is_public is None:
            raise ValueError("Invalid value for `is_public`, must not be `None`")  # noqa: E501

        self._is_public = is_public

    @property
    def job_title(self) -> str:
        """Gets the job_title of this AuthorComplete.

        Job title  # noqa: E501

        :return: The job_title of this AuthorComplete.
        :rtype: str
        """
        return self._job_title

    @job_title.setter
    def job_title(self, job_title: str):
        """Sets the job_title of this AuthorComplete.

        Job title  # noqa: E501

        :param job_title: The job_title of this AuthorComplete.
        :type job_title: str
        """
        if job_title is None:
            raise ValueError("Invalid value for `job_title`, must not be `None`")  # noqa: E501

        self._job_title = job_title
