# coding: utf-8

from __future__ import absolute_import
from datetime import date, datetime  # noqa: F401

from typing import List, Dict  # noqa: F401

from swagger_server.models.base_model_ import Model
from swagger_server import util


class CurationComment(Model):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    def __init__(self, id: int=None, account_id: int=None, type: str=None, text: str=None):  # noqa: E501
        """CurationComment - a model defined in Swagger

        :param id: The id of this CurationComment.  # noqa: E501
        :type id: int
        :param account_id: The account_id of this CurationComment.  # noqa: E501
        :type account_id: int
        :param type: The type of this CurationComment.  # noqa: E501
        :type type: str
        :param text: The text of this CurationComment.  # noqa: E501
        :type text: str
        """
        self.swagger_types = {
            'id': int,
            'account_id': int,
            'type': str,
            'text': str
        }

        self.attribute_map = {
            'id': 'id',
            'account_id': 'account_id',
            'type': 'type',
            'text': 'text'
        }

        self._id = id
        self._account_id = account_id
        self._type = type
        self._text = text

    @classmethod
    def from_dict(cls, dikt) -> 'CurationComment':
        """Returns the dict as a model

        :param dikt: A dict.
        :type: dict
        :return: The CurationComment of this CurationComment.  # noqa: E501
        :rtype: CurationComment
        """
        return util.deserialize_model(dikt, cls)

    @property
    def id(self) -> int:
        """Gets the id of this CurationComment.

        The ID of the comment.  # noqa: E501

        :return: The id of this CurationComment.
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id: int):
        """Sets the id of this CurationComment.

        The ID of the comment.  # noqa: E501

        :param id: The id of this CurationComment.
        :type id: int
        """
        if id is None:
            raise ValueError("Invalid value for `id`, must not be `None`")  # noqa: E501

        self._id = id

    @property
    def account_id(self) -> int:
        """Gets the account_id of this CurationComment.

        The ID of the account which generated this comment.  # noqa: E501

        :return: The account_id of this CurationComment.
        :rtype: int
        """
        return self._account_id

    @account_id.setter
    def account_id(self, account_id: int):
        """Sets the account_id of this CurationComment.

        The ID of the account which generated this comment.  # noqa: E501

        :param account_id: The account_id of this CurationComment.
        :type account_id: int
        """
        if account_id is None:
            raise ValueError("Invalid value for `account_id`, must not be `None`")  # noqa: E501

        self._account_id = account_id

    @property
    def type(self) -> str:
        """Gets the type of this CurationComment.

        The ID of the account which generated this comment.  # noqa: E501

        :return: The type of this CurationComment.
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type: str):
        """Sets the type of this CurationComment.

        The ID of the account which generated this comment.  # noqa: E501

        :param type: The type of this CurationComment.
        :type type: str
        """
        allowed_values = ["comment", "approved", "rejected", "closed"]  # noqa: E501
        if type not in allowed_values:
            raise ValueError(
                "Invalid value for `type` ({0}), must be one of {1}"
                .format(type, allowed_values)
            )

        self._type = type

    @property
    def text(self) -> str:
        """Gets the text of this CurationComment.

        The value/content of the comment.  # noqa: E501

        :return: The text of this CurationComment.
        :rtype: str
        """
        return self._text

    @text.setter
    def text(self, text: str):
        """Sets the text of this CurationComment.

        The value/content of the comment.  # noqa: E501

        :param text: The text of this CurationComment.
        :type text: str
        """
        if text is None:
            raise ValueError("Invalid value for `text`, must not be `None`")  # noqa: E501

        self._text = text
