# coding: utf-8

from __future__ import absolute_import
from datetime import date, datetime  # noqa: F401

from typing import List, Dict  # noqa: F401

from swagger_server.models.base_model_ import Model
from swagger_server import util


class PrivateAuthorsSearch(Model):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    def __init__(self, search_for: str=None, page: int=None, page_size: int=10, limit: int=None, offset: int=None, order: str='published_date', order_direction: str='desc', institution_id: int=None, orcid: str=None, group_id: int=None, is_active: bool=None, is_public: bool=None):  # noqa: E501
        """PrivateAuthorsSearch - a model defined in Swagger

        :param search_for: The search_for of this PrivateAuthorsSearch.  # noqa: E501
        :type search_for: str
        :param page: The page of this PrivateAuthorsSearch.  # noqa: E501
        :type page: int
        :param page_size: The page_size of this PrivateAuthorsSearch.  # noqa: E501
        :type page_size: int
        :param limit: The limit of this PrivateAuthorsSearch.  # noqa: E501
        :type limit: int
        :param offset: The offset of this PrivateAuthorsSearch.  # noqa: E501
        :type offset: int
        :param order: The order of this PrivateAuthorsSearch.  # noqa: E501
        :type order: str
        :param order_direction: The order_direction of this PrivateAuthorsSearch.  # noqa: E501
        :type order_direction: str
        :param institution_id: The institution_id of this PrivateAuthorsSearch.  # noqa: E501
        :type institution_id: int
        :param orcid: The orcid of this PrivateAuthorsSearch.  # noqa: E501
        :type orcid: str
        :param group_id: The group_id of this PrivateAuthorsSearch.  # noqa: E501
        :type group_id: int
        :param is_active: The is_active of this PrivateAuthorsSearch.  # noqa: E501
        :type is_active: bool
        :param is_public: The is_public of this PrivateAuthorsSearch.  # noqa: E501
        :type is_public: bool
        """
        self.swagger_types = {
            'search_for': str,
            'page': int,
            'page_size': int,
            'limit': int,
            'offset': int,
            'order': str,
            'order_direction': str,
            'institution_id': int,
            'orcid': str,
            'group_id': int,
            'is_active': bool,
            'is_public': bool
        }

        self.attribute_map = {
            'search_for': 'search_for',
            'page': 'page',
            'page_size': 'page_size',
            'limit': 'limit',
            'offset': 'offset',
            'order': 'order',
            'order_direction': 'order_direction',
            'institution_id': 'institution_id',
            'orcid': 'orcid',
            'group_id': 'group_id',
            'is_active': 'is_active',
            'is_public': 'is_public'
        }

        self._search_for = search_for
        self._page = page
        self._page_size = page_size
        self._limit = limit
        self._offset = offset
        self._order = order
        self._order_direction = order_direction
        self._institution_id = institution_id
        self._orcid = orcid
        self._group_id = group_id
        self._is_active = is_active
        self._is_public = is_public

    @classmethod
    def from_dict(cls, dikt) -> 'PrivateAuthorsSearch':
        """Returns the dict as a model

        :param dikt: A dict.
        :type: dict
        :return: The PrivateAuthorsSearch of this PrivateAuthorsSearch.  # noqa: E501
        :rtype: PrivateAuthorsSearch
        """
        return util.deserialize_model(dikt, cls)

    @property
    def search_for(self) -> str:
        """Gets the search_for of this PrivateAuthorsSearch.

        Search term  # noqa: E501

        :return: The search_for of this PrivateAuthorsSearch.
        :rtype: str
        """
        return self._search_for

    @search_for.setter
    def search_for(self, search_for: str):
        """Sets the search_for of this PrivateAuthorsSearch.

        Search term  # noqa: E501

        :param search_for: The search_for of this PrivateAuthorsSearch.
        :type search_for: str
        """

        self._search_for = search_for

    @property
    def page(self) -> int:
        """Gets the page of this PrivateAuthorsSearch.

        Page number. Used for pagination with page_size  # noqa: E501

        :return: The page of this PrivateAuthorsSearch.
        :rtype: int
        """
        return self._page

    @page.setter
    def page(self, page: int):
        """Sets the page of this PrivateAuthorsSearch.

        Page number. Used for pagination with page_size  # noqa: E501

        :param page: The page of this PrivateAuthorsSearch.
        :type page: int
        """
        if page is not None and page > 5000:  # noqa: E501
            raise ValueError("Invalid value for `page`, must be a value less than or equal to `5000`")  # noqa: E501
        if page is not None and page < 1:  # noqa: E501
            raise ValueError("Invalid value for `page`, must be a value greater than or equal to `1`")  # noqa: E501

        self._page = page

    @property
    def page_size(self) -> int:
        """Gets the page_size of this PrivateAuthorsSearch.

        The number of results included on a page. Used for pagination with page  # noqa: E501

        :return: The page_size of this PrivateAuthorsSearch.
        :rtype: int
        """
        return self._page_size

    @page_size.setter
    def page_size(self, page_size: int):
        """Sets the page_size of this PrivateAuthorsSearch.

        The number of results included on a page. Used for pagination with page  # noqa: E501

        :param page_size: The page_size of this PrivateAuthorsSearch.
        :type page_size: int
        """
        if page_size is not None and page_size > 1000:  # noqa: E501
            raise ValueError("Invalid value for `page_size`, must be a value less than or equal to `1000`")  # noqa: E501
        if page_size is not None and page_size < 1:  # noqa: E501
            raise ValueError("Invalid value for `page_size`, must be a value greater than or equal to `1`")  # noqa: E501

        self._page_size = page_size

    @property
    def limit(self) -> int:
        """Gets the limit of this PrivateAuthorsSearch.

        Number of results included on a page. Used for pagination with query  # noqa: E501

        :return: The limit of this PrivateAuthorsSearch.
        :rtype: int
        """
        return self._limit

    @limit.setter
    def limit(self, limit: int):
        """Sets the limit of this PrivateAuthorsSearch.

        Number of results included on a page. Used for pagination with query  # noqa: E501

        :param limit: The limit of this PrivateAuthorsSearch.
        :type limit: int
        """
        if limit is not None and limit > 1000:  # noqa: E501
            raise ValueError("Invalid value for `limit`, must be a value less than or equal to `1000`")  # noqa: E501
        if limit is not None and limit < 1:  # noqa: E501
            raise ValueError("Invalid value for `limit`, must be a value greater than or equal to `1`")  # noqa: E501

        self._limit = limit

    @property
    def offset(self) -> int:
        """Gets the offset of this PrivateAuthorsSearch.

        Where to start the listing(the offset of the first result). Used for pagination with limit  # noqa: E501

        :return: The offset of this PrivateAuthorsSearch.
        :rtype: int
        """
        return self._offset

    @offset.setter
    def offset(self, offset: int):
        """Sets the offset of this PrivateAuthorsSearch.

        Where to start the listing(the offset of the first result). Used for pagination with limit  # noqa: E501

        :param offset: The offset of this PrivateAuthorsSearch.
        :type offset: int
        """
        if offset is not None and offset > 5000:  # noqa: E501
            raise ValueError("Invalid value for `offset`, must be a value less than or equal to `5000`")  # noqa: E501
        if offset is not None and offset < 0:  # noqa: E501
            raise ValueError("Invalid value for `offset`, must be a value greater than or equal to `0`")  # noqa: E501

        self._offset = offset

    @property
    def order(self) -> str:
        """Gets the order of this PrivateAuthorsSearch.

        The field by which to order. Default varies by endpoint/resource.  # noqa: E501

        :return: The order of this PrivateAuthorsSearch.
        :rtype: str
        """
        return self._order

    @order.setter
    def order(self, order: str):
        """Sets the order of this PrivateAuthorsSearch.

        The field by which to order. Default varies by endpoint/resource.  # noqa: E501

        :param order: The order of this PrivateAuthorsSearch.
        :type order: str
        """
        allowed_values = ["published_date", "modified_date", "views", "shares", "downloads", "cites"]  # noqa: E501
        if order not in allowed_values:
            raise ValueError(
                "Invalid value for `order` ({0}), must be one of {1}"
                .format(order, allowed_values)
            )

        self._order = order

    @property
    def order_direction(self) -> str:
        """Gets the order_direction of this PrivateAuthorsSearch.

        Direction of ordering  # noqa: E501

        :return: The order_direction of this PrivateAuthorsSearch.
        :rtype: str
        """
        return self._order_direction

    @order_direction.setter
    def order_direction(self, order_direction: str):
        """Sets the order_direction of this PrivateAuthorsSearch.

        Direction of ordering  # noqa: E501

        :param order_direction: The order_direction of this PrivateAuthorsSearch.
        :type order_direction: str
        """
        allowed_values = ["asc", "desc"]  # noqa: E501
        if order_direction not in allowed_values:
            raise ValueError(
                "Invalid value for `order_direction` ({0}), must be one of {1}"
                .format(order_direction, allowed_values)
            )

        self._order_direction = order_direction

    @property
    def institution_id(self) -> int:
        """Gets the institution_id of this PrivateAuthorsSearch.

        Return only authors associated to this institution  # noqa: E501

        :return: The institution_id of this PrivateAuthorsSearch.
        :rtype: int
        """
        return self._institution_id

    @institution_id.setter
    def institution_id(self, institution_id: int):
        """Sets the institution_id of this PrivateAuthorsSearch.

        Return only authors associated to this institution  # noqa: E501

        :param institution_id: The institution_id of this PrivateAuthorsSearch.
        :type institution_id: int
        """

        self._institution_id = institution_id

    @property
    def orcid(self) -> str:
        """Gets the orcid of this PrivateAuthorsSearch.

        Orcid of author  # noqa: E501

        :return: The orcid of this PrivateAuthorsSearch.
        :rtype: str
        """
        return self._orcid

    @orcid.setter
    def orcid(self, orcid: str):
        """Sets the orcid of this PrivateAuthorsSearch.

        Orcid of author  # noqa: E501

        :param orcid: The orcid of this PrivateAuthorsSearch.
        :type orcid: str
        """

        self._orcid = orcid

    @property
    def group_id(self) -> int:
        """Gets the group_id of this PrivateAuthorsSearch.

        Return only authors in this group or subgroups of the group  # noqa: E501

        :return: The group_id of this PrivateAuthorsSearch.
        :rtype: int
        """
        return self._group_id

    @group_id.setter
    def group_id(self, group_id: int):
        """Sets the group_id of this PrivateAuthorsSearch.

        Return only authors in this group or subgroups of the group  # noqa: E501

        :param group_id: The group_id of this PrivateAuthorsSearch.
        :type group_id: int
        """

        self._group_id = group_id

    @property
    def is_active(self) -> bool:
        """Gets the is_active of this PrivateAuthorsSearch.

        Return only active authors if True  # noqa: E501

        :return: The is_active of this PrivateAuthorsSearch.
        :rtype: bool
        """
        return self._is_active

    @is_active.setter
    def is_active(self, is_active: bool):
        """Sets the is_active of this PrivateAuthorsSearch.

        Return only active authors if True  # noqa: E501

        :param is_active: The is_active of this PrivateAuthorsSearch.
        :type is_active: bool
        """

        self._is_active = is_active

    @property
    def is_public(self) -> bool:
        """Gets the is_public of this PrivateAuthorsSearch.

        Return only authors that have published items if True  # noqa: E501

        :return: The is_public of this PrivateAuthorsSearch.
        :rtype: bool
        """
        return self._is_public

    @is_public.setter
    def is_public(self, is_public: bool):
        """Sets the is_public of this PrivateAuthorsSearch.

        Return only authors that have published items if True  # noqa: E501

        :param is_public: The is_public of this PrivateAuthorsSearch.
        :type is_public: bool
        """

        self._is_public = is_public
