# coding: utf-8

from __future__ import absolute_import
from datetime import date, datetime  # noqa: F401

from typing import List, Dict  # noqa: F401

from swagger_server.models.base_model_ import Model
from swagger_server import util


class ProjectNote(Model):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    def __init__(self, id: int=None, user_id: int=None, abstract: str=None, user_name: str=None, created_date: str=None, modified_date: str=None):  # noqa: E501
        """ProjectNote - a model defined in Swagger

        :param id: The id of this ProjectNote.  # noqa: E501
        :type id: int
        :param user_id: The user_id of this ProjectNote.  # noqa: E501
        :type user_id: int
        :param abstract: The abstract of this ProjectNote.  # noqa: E501
        :type abstract: str
        :param user_name: The user_name of this ProjectNote.  # noqa: E501
        :type user_name: str
        :param created_date: The created_date of this ProjectNote.  # noqa: E501
        :type created_date: str
        :param modified_date: The modified_date of this ProjectNote.  # noqa: E501
        :type modified_date: str
        """
        self.swagger_types = {
            'id': int,
            'user_id': int,
            'abstract': str,
            'user_name': str,
            'created_date': str,
            'modified_date': str
        }

        self.attribute_map = {
            'id': 'id',
            'user_id': 'user_id',
            'abstract': 'abstract',
            'user_name': 'user_name',
            'created_date': 'created_date',
            'modified_date': 'modified_date'
        }

        self._id = id
        self._user_id = user_id
        self._abstract = abstract
        self._user_name = user_name
        self._created_date = created_date
        self._modified_date = modified_date

    @classmethod
    def from_dict(cls, dikt) -> 'ProjectNote':
        """Returns the dict as a model

        :param dikt: A dict.
        :type: dict
        :return: The ProjectNote of this ProjectNote.  # noqa: E501
        :rtype: ProjectNote
        """
        return util.deserialize_model(dikt, cls)

    @property
    def id(self) -> int:
        """Gets the id of this ProjectNote.

        Project note id  # noqa: E501

        :return: The id of this ProjectNote.
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id: int):
        """Sets the id of this ProjectNote.

        Project note id  # noqa: E501

        :param id: The id of this ProjectNote.
        :type id: int
        """
        if id is None:
            raise ValueError("Invalid value for `id`, must not be `None`")  # noqa: E501

        self._id = id

    @property
    def user_id(self) -> int:
        """Gets the user_id of this ProjectNote.

        User who wrote the note  # noqa: E501

        :return: The user_id of this ProjectNote.
        :rtype: int
        """
        return self._user_id

    @user_id.setter
    def user_id(self, user_id: int):
        """Sets the user_id of this ProjectNote.

        User who wrote the note  # noqa: E501

        :param user_id: The user_id of this ProjectNote.
        :type user_id: int
        """
        if user_id is None:
            raise ValueError("Invalid value for `user_id`, must not be `None`")  # noqa: E501

        self._user_id = user_id

    @property
    def abstract(self) -> str:
        """Gets the abstract of this ProjectNote.

        Note Abstract - short/truncated content  # noqa: E501

        :return: The abstract of this ProjectNote.
        :rtype: str
        """
        return self._abstract

    @abstract.setter
    def abstract(self, abstract: str):
        """Sets the abstract of this ProjectNote.

        Note Abstract - short/truncated content  # noqa: E501

        :param abstract: The abstract of this ProjectNote.
        :type abstract: str
        """
        if abstract is None:
            raise ValueError("Invalid value for `abstract`, must not be `None`")  # noqa: E501

        self._abstract = abstract

    @property
    def user_name(self) -> str:
        """Gets the user_name of this ProjectNote.

        Username of the one who wrote the note  # noqa: E501

        :return: The user_name of this ProjectNote.
        :rtype: str
        """
        return self._user_name

    @user_name.setter
    def user_name(self, user_name: str):
        """Sets the user_name of this ProjectNote.

        Username of the one who wrote the note  # noqa: E501

        :param user_name: The user_name of this ProjectNote.
        :type user_name: str
        """
        if user_name is None:
            raise ValueError("Invalid value for `user_name`, must not be `None`")  # noqa: E501

        self._user_name = user_name

    @property
    def created_date(self) -> str:
        """Gets the created_date of this ProjectNote.

        Date when note was created  # noqa: E501

        :return: The created_date of this ProjectNote.
        :rtype: str
        """
        return self._created_date

    @created_date.setter
    def created_date(self, created_date: str):
        """Sets the created_date of this ProjectNote.

        Date when note was created  # noqa: E501

        :param created_date: The created_date of this ProjectNote.
        :type created_date: str
        """
        if created_date is None:
            raise ValueError("Invalid value for `created_date`, must not be `None`")  # noqa: E501

        self._created_date = created_date

    @property
    def modified_date(self) -> str:
        """Gets the modified_date of this ProjectNote.

        Date when note was last modified  # noqa: E501

        :return: The modified_date of this ProjectNote.
        :rtype: str
        """
        return self._modified_date

    @modified_date.setter
    def modified_date(self, modified_date: str):
        """Sets the modified_date of this ProjectNote.

        Date when note was last modified  # noqa: E501

        :param modified_date: The modified_date of this ProjectNote.
        :type modified_date: str
        """
        if modified_date is None:
            raise ValueError("Invalid value for `modified_date`, must not be `None`")  # noqa: E501

        self._modified_date = modified_date
